# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CustomNamingCounter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'cn_resource_type': 'str',
        'current_counter': 'int',
        'active': 'bool',
        'project_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'cn_resource_type': 'cnResourceType',
        'current_counter': 'currentCounter',
        'active': 'active',
        'project_id': 'projectId'
    }

    def __init__(self, id=None, cn_resource_type=None, current_counter=None, active=None, project_id=None):  # noqa: E501
        """CustomNamingCounter - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._cn_resource_type = None
        self._current_counter = None
        self._active = None
        self._project_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.cn_resource_type = cn_resource_type
        self.current_counter = current_counter
        if active is not None:
            self.active = active
        self.project_id = project_id

    @property
    def id(self):
        """Gets the id of this CustomNamingCounter.  # noqa: E501


        :return: The id of this CustomNamingCounter.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomNamingCounter.


        :param id: The id of this CustomNamingCounter.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def cn_resource_type(self):
        """Gets the cn_resource_type of this CustomNamingCounter.  # noqa: E501

        The resource type of custom name  # noqa: E501

        :return: The cn_resource_type of this CustomNamingCounter.  # noqa: E501
        :rtype: str
        """
        return self._cn_resource_type

    @cn_resource_type.setter
    def cn_resource_type(self, cn_resource_type):
        """Sets the cn_resource_type of this CustomNamingCounter.

        The resource type of custom name  # noqa: E501

        :param cn_resource_type: The cn_resource_type of this CustomNamingCounter.  # noqa: E501
        :type: str
        """
        if cn_resource_type is None:
            raise ValueError("Invalid value for `cn_resource_type`, must not be `None`")  # noqa: E501
        allowed_values = ["COMPUTE", "NETWORK", "COMPUTE_STORAGE", "LOAD_BALANCER", "RESOURCE_GROUP", "GATEWAY", "NAT", "SECURITY_GROUP", "GENERIC"]  # noqa: E501
        if cn_resource_type not in allowed_values:
            raise ValueError(
                "Invalid value for `cn_resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(cn_resource_type, allowed_values)
            )

        self._cn_resource_type = cn_resource_type

    @property
    def current_counter(self):
        """Gets the current_counter of this CustomNamingCounter.  # noqa: E501

        The current counter of custom name  # noqa: E501

        :return: The current_counter of this CustomNamingCounter.  # noqa: E501
        :rtype: int
        """
        return self._current_counter

    @current_counter.setter
    def current_counter(self, current_counter):
        """Sets the current_counter of this CustomNamingCounter.

        The current counter of custom name  # noqa: E501

        :param current_counter: The current_counter of this CustomNamingCounter.  # noqa: E501
        :type: int
        """
        if current_counter is None:
            raise ValueError("Invalid value for `current_counter`, must not be `None`")  # noqa: E501

        self._current_counter = current_counter

    @property
    def active(self):
        """Gets the active of this CustomNamingCounter.  # noqa: E501


        :return: The active of this CustomNamingCounter.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this CustomNamingCounter.


        :param active: The active of this CustomNamingCounter.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def project_id(self):
        """Gets the project_id of this CustomNamingCounter.  # noqa: E501

        The project id to which the counter is mapped  # noqa: E501

        :return: The project_id of this CustomNamingCounter.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this CustomNamingCounter.

        The project id to which the counter is mapped  # noqa: E501

        :param project_id: The project_id of this CustomNamingCounter.  # noqa: E501
        :type: str
        """
        if project_id is None:
            raise ValueError("Invalid value for `project_id`, must not be `None`")  # noqa: E501

        self._project_id = project_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomNamingCounter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomNamingCounter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
